"use strict";exports.__esModule=true;exports.ChunkGraphPlugin=void 0;var _crypto=require("crypto");var _fs=_interopRequireDefault(require("fs"));var _constants=require("next-server/constants");var _os=require("os");var _path=_interopRequireDefault(require("path"));var _querystring=require("querystring");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function getFiles(dir,modules){if(!(modules&&modules.length)){return[];}function getFileByIdentifier(id){if(id.startsWith('external ')||id.startsWith('multi ')){return null;}let n;if((n=id.lastIndexOf('!'))!==-1){id=id.substring(n+1);}if(id&&!_path.default.isAbsolute(id)){id=_path.default.resolve(dir,id);}return id;}return modules.reduce((acc,val)=>val.modules?acc.concat(getFiles(dir,val.modules)):(acc.push(getFileByIdentifier(typeof val.identifier==='function'?val.identifier():val.identifier)),acc),[]).filter(Boolean);}class ChunkGraphPlugin{constructor(buildId,dir,{filename,selectivePageBuildingCacheIdentifier}={}){this.buildId=void 0;this.dir=void 0;this.filename=void 0;this.selectivePageBuildingCacheIdentifier=void 0;this.buildId=buildId;this.dir=dir;this.filename=filename||'chunk-graph-manifest.json';this.selectivePageBuildingCacheIdentifier=selectivePageBuildingCacheIdentifier||'';}apply(compiler){const{dir}=this;compiler.hooks.emit.tap('ChunkGraphPlugin',compilation=>{const manifest={pages:{},pageChunks:{},chunks:{},hashes:{}};const sharedFiles=[];const sharedChunks=[];const pages={};const pageChunks={};const allFiles=new Set();compilation.chunks.forEach(chunk=>{if(!chunk.hasEntryModule()){return;}const chunkModules=new Map();const queue=new Set(chunk.groupsIterable);const chunksProcessed=new Set();const involvedChunks=new Set();for(const chunkGroup of queue){for(const chunk of chunkGroup.chunks){chunk.files.forEach(file=>involvedChunks.add(file));if(!chunksProcessed.has(chunk)){chunksProcessed.add(chunk);for(const m of chunk.modulesIterable){chunkModules.set(m.id,m);}}}for(const child of chunkGroup.childrenIterable){queue.add(child);}}const modules=[...chunkModules.values()];const files=getFiles(dir,modules).filter(val=>!val.includes('node_modules')).map(f=>_path.default.relative(dir,f)).sort();files.forEach(f=>allFiles.add(f));let pageName;if(chunk.entryModule&&chunk.entryModule.loaders){const entryLoader=chunk.entryModule.loaders.find(({loader,options})=>loader&&loader.includes('next-client-pages-loader')&&options);if(entryLoader){const{page}=(0,_querystring.parse)(entryLoader.options);if(typeof page==='string'&&page){pageName=page;}}}if(pageName){if(pageName==='/_app'||pageName==='/_error'||pageName==='/_document'){sharedFiles.push(...files);sharedChunks.push(...involvedChunks);}else{pages[pageName]=files;pageChunks[pageName]=[...involvedChunks];}}else{if(chunk.name===_constants.CLIENT_STATIC_FILES_RUNTIME_MAIN){sharedFiles.push(...files);sharedChunks.push(...involvedChunks);}else{manifest.chunks[chunk.name]=files;}}});const getLambdaChunk=name=>name.includes(this.buildId)?name.replace(new RegExp(`${this.buildId}[\\/\\\\]`),'client/').replace(/[.]js$/,`.${this.buildId}.js`):name;for(const page in pages){manifest.pages[page]=[...pages[page],...sharedFiles];manifest.pageChunks[page]=[...new Set([...pageChunks[page],...pageChunks[page].map(getLambdaChunk),...sharedChunks,...sharedChunks.map(getLambdaChunk)])].sort();}manifest.hashes=[...allFiles].sort().reduce((acc,cur)=>Object.assign(acc,_fs.default.existsSync(_path.default.join(dir,cur))?{[cur]:(0,_crypto.createHash)('sha1').update(this.selectivePageBuildingCacheIdentifier).update(_fs.default.readFileSync(_path.default.join(dir,cur))).digest('hex')}:undefined),{});const json=JSON.stringify(manifest,null,2)+_os.EOL;compilation.assets[this.filename]={source(){return json;},size(){return json.length;}};});}}exports.ChunkGraphPlugin=ChunkGraphPlugin;